unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, system.Math, Vcl.ExtDlgs, Vcl.ExtCtrls, System.UIConsts,
  Vcl.StdCtrls, System.UITypes, Vcl.Imaging.GIFImg;

type
  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    ScrollBox1: TScrollBox;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    Image2: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    FileSaveBtn: TButton;
    GroupBox1: TGroupBox;
    hard_maskBtn: TButton;
    LabeledEdit1: TLabeledEdit;
    GroupBox2: TGroupBox;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Soft_maskBtn: TButton;
    ScrollBox3: TScrollBox;
    Image3: TImage;
    ScrollBox4: TScrollBox;
    Image4: TImage;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Image5: TImage;
    ScrollBar1: TScrollBar;
    LabeledEdit4: TLabeledEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure hard_maskBtnClick(Sender: TObject);
    procedure Soft_maskBtnClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
    procedure hard_mask;
    procedure soft_mask;
    procedure composit;
    procedure ColorBar;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray  = ^TPrgbarry;                    // |C^[


const
// t@Cgqݒ
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

var
  InpBitmap       : TBitmap;                 // Oirbg}bv
  BakBitmap       : TBitmap;                 // wirbg}bv
  OutBitmap       : TBitmap;
  GHeight, GWidth : Integer;                 // Oi摜TCY
  BHeight, BWidth : Integer;                 // wi摜TCY
  ImageKey        : array of array of byte;
  FImage          : Byte;                    // C[WtO 1bit Oi  2bit wi
  Maxhue, Minhue  : double;
  huein           : Single;

//=====================
// J[o[}
//=====================
procedure TForm1.ColorBar;
var
  h   : integer;
  hue : double;
  Cor : TColor;
begin
  for h := 0 to 360 do begin
    hue := h / 360;
    Cor := HSLtoRGB(hue, 1, 0.5);            // x0.5  0.5 F
    Image5.Canvas.Pen.Color := Cor and $00FFFFFF;
    Image5.Canvas.MoveTo(h, 0);
    Image5.Canvas.LineTo(h, image2.Height);
  end;
end;

//==========================
// Oi摜瓧ߐFo
//==========================
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Pcolor: TAlphacolor;
  S, L  : Single;
  Spos  : Integer;
begin
  Pcolor := image1.Canvas.Pixels[X, Y];
  RGBtoHsl(Pcolor, huein, S, L);
  Spos := Round(huein * 360);
  if Spos >= 360 then Spos := 0;
  ScrollBar1.Position := Spos;
  Maxhue := huein + 0.05;
  if Maxhue >= 1 then Maxhue := Maxhue - 1;
  MinHue := huein - 0.05;
  if MinHue < 0 then MinHue := Minhue + 1;
end;

//=========================
// 
//=========================
procedure TForm1.composit;
var
  PinpB  : Prgbarray;
  PbakB  : Prgbarray;
  PoutB  : Prgbarray;
  YY, XX : Integer;
  Key    : Byte;
begin
  for YY := 0 to GHeight - 1 do begin
    PinpB := InpBitmap.ScanLine[YY];
    PbakB := BakBitmap.ScanLine[YY];
    PoutB := OutBitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      Key := ImageKey[YY, XX];
      PoutB[XX].rgbtBlue  := (PinpB[XX].rgbtBlue  * Key + PbakB[XX].rgbtBlue  * (MaxByte - Key)) div MaxByte;
      PoutB[XX].rgbtGreen := (PinpB[XX].rgbtGreen * Key + PbakB[XX].rgbtGreen * (MaxByte - Key)) div MaxByte;
      PoutB[XX].rgbtRed   := (PinpB[XX].rgbtRed   * Key + PbakB[XX].rgbtRed   * (MaxByte - Key)) div MaxByte;
    end;
  end;
  image4.Picture.Bitmap := OutBitmap;                   // 摜\
  FileSaveBtn.Enabled := False;
end;

//========================
// lL[}XN̐
//========================
procedure TForm1.hard_mask;
var
  C      : Integer;
  PinpB  : Prgbarray;
  PoutB  : Prgbarray;
  YY, XX : Integer;
  DColor : Tcolor;
  Data   : Single;
  S, L   : Single;
  MaXL   : Single;
  GosaHu : Single;
begin
  if ScrollBar1.Position < 0 then begin
    application.MessageBox('F̎w肪Ă܂B', '', 0);
    exit;
  end;
  val(LabeledEdit1.Text, MaXL, C);
  if C<>0 then begin
    application.MessageBox('臒l͂lł͂܂', '', 0);
    exit;
  end;
  val(LabeledEdit4.Text, GosaHu, C);
  if C<>0 then begin
    application.MessageBox('F덷llł͂܂', '', 0);
    exit;
  end;
  maxhue := huein + GosaHu;
  minhue := huein - GosaHu;
  for YY := 0 to GHeight - 1 do begin
    PinpB := InpBitmap.ScanLine[YY];
    PoutB := OutBitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      DColor := RGB(PinpB[XX].rgbtRed, PinpB[XX].rgbtGreen, PinpB[XX].rgbtBlue);
      RGBtoHSL(DColor, Data, S, L);
      if Data = 1 then Data := 0;
      if maxhue < minhue then begin
        if ((Data < maxhue) or (Data > minhue)) and (L <= MaXL) then ImageKey[YY, XX] := 0
          else ImageKey[YY, XX] := 255;
      end
      else begin
        if (Data < maxhue) and (Data > minhue)  and (L <= MaXL) then ImageKey[YY, XX] := 0
          else ImageKey[YY, XX] := 255;
      end;
      PoutB[XX].rgbtBlue  := ImageKey[YY, XX];
      PoutB[XX].rgbtGreen := ImageKey[YY, XX];
      PoutB[XX].rgbtRed   := ImageKey[YY, XX];
    end;
  end;
  image2.Picture.Bitmap := OutBitmap;                   // 摜\
  composit;
end;

//==================
// l}XN
//==================
procedure TForm1.hard_maskBtnClick(Sender: TObject);
begin
  hard_mask;
end;

//========================
// lL[}XN̐
//========================
procedure TForm1.soft_mask;
var
  threshHi  : Single;
  threshLow : Single;
  C      : Integer;
  PinpB  : Prgbarray;
  PoutB  : Prgbarray;
  YY, XX : Integer;
  Data   : Single;
  DK     : Integer;
  GosaHu : Single;
  DColor : TColor;
  S, L   : Single;
begin
  if ScrollBar1.Position < 0 then begin
    application.MessageBox('F̎w肪Ă܂B', '', 0);
    exit;
  end;
  val(LabeledEdit4.Text, GosaHu, C);
  if C<>0 then begin
    application.MessageBox('F덷llł͂܂', '', 0);
    exit;
  end;
  maxhue := huein + GosaHu;
  minhue := huein - GosaHu;
  val(LabeledEdit2.Text, threshHi, C);
  if C <> 0 then begin
    application.MessageBox('lL[臒l@̐lł͂܂B','', 0);
    exit;
  end;
  val(LabeledEdit3.Text, threshLow, C);
  if C <> 0 then begin
    application.MessageBox('lL[臒l@̐lł͂܂B','', 0);
    exit;
  end;
  if threshHi <= threshLow then begin
    application.MessageBox('臒l̒lAƉA傫łB','', 0);
    exit;
  end;
  for YY := 0 to GHeight - 1 do begin
    PinpB := InpBitmap.ScanLine[YY];
    PoutB := OutBitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      DColor := RGB(PinpB[XX].rgbtRed, PinpB[XX].rgbtGreen, PinpB[XX].rgbtBlue);
      RGBtoHSL(DColor, Data, S, L);
      if Data = 1 then Data := 0;
//      L := (PinpB[XX].rgbtRed * 2 + PinpB[XX].rgbtGreen * 4 + PinpB[XX].rgbtBlue) / 255 / 7;
      DK := 255;
      if maxhue < minhue then begin
        if ((Data < maxhue) or (Data > minhue)) and (L <= threshHi) then DK := 0;
      end
      else
        if (Data < maxhue) and (Data > minhue)  and (L <= threshHi) then DK := 0;
      if DK <> 0 then begin
        if (L - threshLow) < 0 then DK := 255
          else begin
            DK := round(255 / (threshHi - threshLow) * (L - threshLow));
            if DK > 255 then DK := 255;
            if DK < 0 then DK := 0;
          end;
      end;
      ImageKey[YY, XX] := DK;
      PoutB[XX].rgbtBlue  := DK;
      PoutB[XX].rgbtGreen := DK;
      PoutB[XX].rgbtRed   := DK;
    end;
  end;
  image2.Picture.Bitmap := OutBitmap;                   // 摜\
  composit;
end;

//=============================
// lL[
//=============================
procedure TForm1.Soft_maskBtnClick(Sender: TObject);
begin
  soft_mask;
end;

//========================================
// t@C̎wI[v
// I[v摜\
//========================================
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        if RadioGroup1.ItemIndex = 0 then begin
          GHeight := WIC.Height;                              // 摜擾
          GWidth  := WIC.Width;                               // 摜
          InpBitmap.Width   := GWidth;                        // 摜
          InpBitmap.Height  := GHeight;                       // 摜
          InpBitmap.Canvas.Draw(0, 0, WIC);                   // DrawInBitmapɓ͉摜ݒtH[}bg32rbgɕϊ܂
          image1.Picture.Bitmap := InpBitmap;                 // Oi摜\
          FImage := FImage or 1;                              // C[WtO 1bit Oi  2bit wi
        end
        else Begin
          BHeight := WIC.Height;                              // 摜擾
          BWidth  := WIC.Width;                               // 摜
          BakBitmap.Width   := BWidth;                        // 摜
          BakBitmap.Height  := BHeight;                       // 摜
          BakBitmap.Canvas.Draw(0, 0, WIC);                   // DrawInBitmapɓ͉摜ݒtH[}bg32rbgɕϊ܂
          image3.Picture.Bitmap := BakBitmap;                 // wi摜\
          FImage := FImage or 2;                              // C[WtO 1bit Oi  2bit wi
        end;
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  if (FImage and 3 = 3)
    and (GHeight = BHeight)
    and (GWidth  = BWidth) then begin
      hard_maskBtn.Enabled := True;
      Soft_maskBtn.Enabled := True;
      OutBitmap.Width   := GWidth;                            // o͉摜
      OutBitmap.Height  := GHeight;                           // o͉摜
      Setlength(ImageKey, GHeight, GWidth);
    end
    else begin
      hard_maskBtn.Enabled := False;
      Soft_maskBtn.Enabled := False;
      if FImage and 3 = 3 then
        application.MessageBox('Oi摜̃TCYƔwi摜̃TCYႢ܂', '', 0);
    end;
end;

//===================================
// 摜̃t@Cւ̕ۑ
//===================================
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                             // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                 // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                               // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');    // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                          // gqo
  if not WFormatSet then begin                                              // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                       // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                           // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                 // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                  // TWicImage
  try
    WIC.Assign(OutBitmap);                                                  // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                                // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                  // t@C̏o
  finally                                                                   // XE3,XE4̏ꍇ̓AV[v}XLOQƂĂ
    WIC.Free;                                                               // TWicImage
  end;
end;

//============
// ݒ
//============
procedure TForm1.FormCreate(Sender: TObject);
begin
  Top  := (Screen.Height - Height) div 2;     // \ʒuݒ
  Left := (Screen.Width - Width)   div 2;
  InpBitmap     := TBitmap.Create;            // Oi摜p
  BakBitmap     := TBitmap.Create;            // wi摜p
  OutBitmap     := TBitmap.Create;            // o͉摜p
  InpBitmap.PixelFormat   := pf24bit;         // 24rbgJ[ɐݒ
  BakBitmap.PixelFormat   := pf24bit;         // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf24bit;         // 24rbgJ[ɐݒ
  FImage := 0;                                // 摜̓tOZbg
  FileSaveBtn.Enabled := False;
  hard_maskBtn.Enabled := False;
  Soft_maskBtn.Enabled := False;
  ColorBar;
end;

//===============
// I
//===============
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InpBitmap.Free;
  BakBitmap.Free;
  OutBitmap.Free;
end;

end.
