unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, system.Math, Vcl.ExtDlgs, Vcl.ExtCtrls, System.UIConsts,
  Vcl.StdCtrls, System.UITypes, Vcl.Imaging.GIFImg;

type
  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    ScrollBox1: TScrollBox;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    Image2: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    FileSaveBtn: TButton;
    GroupBox1: TGroupBox;
    hard_maskBtn: TButton;
    LabeledEdit1: TLabeledEdit;
    GroupBox2: TGroupBox;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Soft_maskBtn: TButton;
    ScrollBox3: TScrollBox;
    Image3: TImage;
    ScrollBox4: TScrollBox;
    Image4: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    GroupBox3: TGroupBox;
    RedEdit: TLabeledEdit;
    GreenEdit: TLabeledEdit;
    BlueEdit: TLabeledEdit;
    BakFileOpenBtn: TButton;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure hard_maskBtnClick(Sender: TObject);
    procedure Soft_maskBtnClick(Sender: TObject);
    procedure BakFileOpenBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure FileOpen(InF : Boolean);
    procedure hard_mask;
    procedure soft_mask;
    procedure composit;
    function key_coefficient: Boolean;
    procedure MaxMin;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray  = ^TPrgbarry;                    // |C^[


const
// t@Cgqݒ
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

var
  InpBitmap       : TBitmap;                 // Oirbg}bv
  BakBitmap       : TBitmap;                 // wirbg}bv
  OutBitmap       : TBitmap;                 // o͗prbg}bv
  GHeight, GWidth : Integer;                 // Oi摜TCY
  BHeight, BWidth : Integer;                 // wi摜TCY
  ImageKey        : array of array of byte;  // }XNpL[z
  FImage          : Byte;                    // C[WtO 1bit Oi  2bit wi
  Rkey, Gkey, Bkey: double;                  // L[쐬pFW
  Dmax, Dmin      : smallint;                // őlŏl

//==============================
// L[쐬pFW ݒ
//==============================
function TForm1.key_coefficient: Boolean;
var
  C : Integer;
begin
  Result := True;
  Val(Rededit.Text, Rkey, C);
  if C <> 0 then begin
    application.MessageBox('ԃL[̒l@lł͂܂B','', 0);
    Result := False;
    exit;
  end;
  val(Greenedit.Text, Gkey, C);
  if C <> 0 then begin
    application.MessageBox('΃L[̒l@lł͂܂B','', 0);
    Result := False;
    exit;
  end;
  val(Blueedit.Text, Bkey, C);
  if C <> 0 then begin
    application.MessageBox('L[̒l@lł͂܂B','', 0);
    Result := False;
    exit;
  end;
end;

//==========================
// L[őlŏl\
//==========================
procedure TForm1.MaxMin;
begin
  LabeledEdit4.Text := intTostr(Dmax);
  LabeledEdit5.Text := intTostr(Dmin);
end;


//=======================================================
// 
// Key = 0 ̏ꍇ wi 255̏ꍇOi
// lɉāAOi̒lƔwi̒l䗦ŉZ
//=======================================================
procedure TForm1.composit;
var
  PinpB     : Prgbarray;
  PbakB     : Prgbarray;
  PoutB     : Prgbarray;
  YY, XX    : Integer;
  Key, Mkey : Byte;
begin
  for YY := 0 to GHeight - 1 do begin
    PinpB := InpBitmap.ScanLine[YY];
    PbakB := BakBitmap.ScanLine[YY];
    PoutB := OutBitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      // pL[f[^[
      Key  := ImageKey[YY, XX];
      MKey := MaxByte - Key;
      // Key̒lŁAeF̒lݒ
      PoutB[XX].rgbtBlue  := (PinpB[XX].rgbtBlue  * Key + PbakB[XX].rgbtBlue  * MKey) div MaxByte;
      PoutB[XX].rgbtGreen := (PinpB[XX].rgbtGreen * Key + PbakB[XX].rgbtGreen * MKey) div MaxByte;
      PoutB[XX].rgbtRed   := (PinpB[XX].rgbtRed   * Key + PbakB[XX].rgbtRed   * MKey) div MaxByte;
    end;
  end;
  image4.Picture.Bitmap := OutBitmap;                   // 摜\
  FileSaveBtn.Enabled := True;
end;


//========================
// lL[}XN̐
//========================
procedure TForm1.hard_mask;
var
  thresh : Smallint;
  C      : Integer;
  PinpB  : Prgbarray;
  PoutB  : Prgbarray;
  YY, XX : Integer;
  Data   : Smallint;
begin
  val(LabeledEdit1.Text, thresh, C);
  if C <> 0 then begin
    application.MessageBox('lL[̒l@̐lł͂܂B','', 0);
    exit;
  end;
  Dmin :=  255 * 3;
  DMax := -255 * 3;
  for YY := 0 to GHeight - 1 do begin
    PinpB := InpBitmap.ScanLine[YY];
    PoutB := OutBitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      Data := round(PinpB[XX].rgbtRed * Rkey + PinpB[XX].rgbtGreen * Gkey+ PinpB[XX].rgbtBlue * Bkey);
      if Dmin > Data then Dmin := Data;
      if DMax < Data then Dmax := Data;
      if Data >= thresh then ImageKey[YY, XX] := 255
                        else ImageKey[YY, XX] := 0;
      PoutB[XX].rgbtBlue  := ImageKey[YY, XX];
      PoutB[XX].rgbtGreen := ImageKey[YY, XX];
      PoutB[XX].rgbtRed   := ImageKey[YY, XX];
    end;
  end;
  image2.Picture.Bitmap := OutBitmap;                   // 摜\
  MaxMin;
end;

//==========================
// lL[ɂ鍇
//==========================
procedure TForm1.hard_maskBtnClick(Sender: TObject);
begin
  if not key_coefficient then exit;
  hard_mask;
  composit;
end;

//========================
// lL[}XN̐
//========================
procedure TForm1.soft_mask;
var
  threshHi  : Smallint;
  threshLow : Smallint;
  C      : Integer;
  PinpB  : Prgbarray;
  PoutB  : Prgbarray;
  YY, XX : Integer;
  Data   : Integer;
  DK     : Integer;
begin
  val(LabeledEdit2.Text, threshHi, C);
  if C <> 0 then begin
    application.MessageBox('lL[臒l@̐lł͂܂B','', 0);
    exit;
  end;
  val(LabeledEdit3.Text, threshLow, C);
  if C <> 0 then begin
    application.MessageBox('lL[臒l@̐lł͂܂B','', 0);
    exit;
  end;
  if threshHi <= threshLow then begin
    application.MessageBox('臒l̒lAƉA傫łB','', 0);
    exit;
  end;
  Dmin :=  255 * 3;
  DMax := -255 * 3;
  for YY := 0 to GHeight - 1 do begin
    PinpB := InpBitmap.ScanLine[YY];
    PoutB := OutBitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      // FWɂOF̒lZ
      Data := Round(PinpB[XX].rgbtRed * Rkey + PinpB[XX].rgbtGreen * GKey + PinpB[XX].rgbtBlue * Bkey);
      if Dmin > Data then Dmin := Data;
      if DMax < Data then Dmax := Data;
      DK := Round((Data - threshLow) * 255 / (threshHi - threshLow));
      if DK > 255 then DK := 255;
      if DK < 0   then DK := 0;
      ImageKey[YY, XX] := DK;
      PoutB[XX].rgbtBlue  := DK;
      PoutB[XX].rgbtGreen := DK;
      PoutB[XX].rgbtRed   := DK;
    end;
  end;
  image2.Picture.Bitmap := OutBitmap;                   // 摜\
  MaxMin;
end;

//================================
// lL[
//================================
procedure TForm1.Soft_maskBtnClick(Sender: TObject);
begin
  if not key_coefficient then exit;
  soft_mask;
  composit;
end;

//========================================================
// t@C̎wI[v
// I[v摜\ TreuőOiI[v FasleŔwiI[v
// OiƔwỉ摜TCY𓯂ɂĂKv܂
//========================================================
procedure TForm1.FileOpen(InF : Boolean);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        // Oi摜ǂݍ
        if InF then begin
          GHeight := WIC.Height;                              // 摜擾
          GWidth  := WIC.Width;                               // 摜
          InpBitmap.Width   := GWidth;                        // 摜
          InpBitmap.Height  := GHeight;                       // 摜
          InpBitmap.Canvas.Draw(0, 0, WIC);                   // DrawInBitmapɓ͉摜ݒtH[}bg32rbgɕϊ܂
          image1.Picture.Bitmap := InpBitmap;                 // Oi摜\
          FImage := FImage or 1;                              // C[WtO 1bit Oi  2bit wi
        end
        // wi摜ǂݍ
        else Begin
          BHeight := WIC.Height;                              // 摜擾
          BWidth  := WIC.Width;                               // 摜
          BakBitmap.Width   := BWidth;                        // 摜
          BakBitmap.Height  := BHeight;                       // 摜
          BakBitmap.Canvas.Draw(0, 0, WIC);                   // DrawInBitmapɓ͉摜ݒtH[}bg32rbgɕϊ܂
          image3.Picture.Bitmap := BakBitmap;                 // wi摜\
          FImage := FImage or 2;                              // C[WtO 1bit Oi  2bit wi
        end;
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  // Oi摜Ɣwi摜̃TCYmF
  if (FImage and 3 = 3)
    and (GHeight = BHeight)
    and (GWidth = BWidth) then begin
      hard_maskBtn.Enabled := True;
      Soft_maskBtn.Enabled := True;
      OutBitmap.Width   := GWidth;                            // o͉摜
      OutBitmap.Height  := GHeight;                           // o͉摜
      Setlength(ImageKey, GHeight, GWidth);
    end
    else begin
      hard_maskBtn.Enabled := False;
      Soft_maskBtn.Enabled := False;
      if FImage and 3 = 3 then
        application.MessageBox('Oi摜̃TCYƔwi摜̃TCYႢ܂', '', 0);
    end;
end;

//==================================
// Oi摜ǂݍ
//==================================
procedure TForm1.FileOpenBtnClick(Sender: TObject);
begin
  FileOpen(True);
end;

//==================================
// wi摜ǂݍ
//==================================
procedure TForm1.BakFileOpenBtnClick(Sender: TObject);
begin
  FileOpen(False);
end;

//===================================
// 摜̃t@Cւ̕ۑ
//===================================
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                             // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                 // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                               // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');    // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                          // gqo
  if not WFormatSet then begin                                              // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                       // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                           // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                 // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                  // TWicImage
  try
    WIC.Assign(OutBitmap);                                                  // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                                // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                  // t@C̏o
  finally                                                                   // XE3,XE4̏ꍇ̓AV[v}XLOQƂĂ
    WIC.Free;                                                               // TWicImage
  end;
end;

//============
// ݒ
//============
procedure TForm1.FormCreate(Sender: TObject);
begin
  Top  := (Screen.Height - Height) div 2;     // \ʒuݒ
  Left := (Screen.Width - Width)   div 2;
  InpBitmap     := TBitmap.Create;            // Oi摜p
  BakBitmap     := TBitmap.Create;            // wi摜p
  OutBitmap     := TBitmap.Create;            // o͉摜p
  InpBitmap.PixelFormat   := pf24bit;         // 24rbgJ[ɐݒ
  BakBitmap.PixelFormat   := pf24bit;         // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf24bit;         // 24rbgJ[ɐݒ
  FImage := 0;                                // C[WtO 1bit Oi  2bit wi
  FileSaveBtn.Enabled := False;               // 摜̓tOZbg
  hard_maskBtn.Enabled := False;
  Soft_maskBtn.Enabled := False;
end;

//===============
// I
//===============
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InpBitmap.Free;
  BakBitmap.Free;
  OutBitmap.Free;
end;

end.
